/*
 * typeinfo.cpp
 *
 * Created on: Apr 14, 2016
 * Author: Jan Travnicek
 */

#include <typeinfo>

namespace std {

	string type_name(const std::type_info& type) {
		return type_name ( type_index ( type ) );
	}

	string type_name(const std::type_index& type) {
		int status;

		char* demangled = abi::__cxa_demangle(type.name(), 0, 0, &status);
		string res ( demangled );
		free ( demangled );
		return res;
	}
} /* namespace std */
